/*
Core

Core API is used to manage resources around organisation like auth, set webhooks per channels, manage campaigns.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package coreapi

import (
	"encoding/json"
)

// checks if the GetChannelTags200Response type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &GetChannelTags200Response{}

// GetChannelTags200Response struct for GetChannelTags200Response
type GetChannelTags200Response struct {
	Results []GetChannelTags200ResponseResultsInner `json:"results,omitempty"`
	Total *int32 `json:"total,omitempty"`
}

// NewGetChannelTags200Response instantiates a new GetChannelTags200Response object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewGetChannelTags200Response() *GetChannelTags200Response {
	this := GetChannelTags200Response{}
	return &this
}

// NewGetChannelTags200ResponseWithDefaults instantiates a new GetChannelTags200Response object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewGetChannelTags200ResponseWithDefaults() *GetChannelTags200Response {
	this := GetChannelTags200Response{}
	return &this
}

// GetResults returns the Results field value if set, zero value otherwise.
func (o *GetChannelTags200Response) GetResults() []GetChannelTags200ResponseResultsInner {
	if o == nil || IsNil(o.Results) {
		var ret []GetChannelTags200ResponseResultsInner
		return ret
	}
	return o.Results
}

// GetResultsOk returns a tuple with the Results field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GetChannelTags200Response) GetResultsOk() ([]GetChannelTags200ResponseResultsInner, bool) {
	if o == nil || IsNil(o.Results) {
		return nil, false
	}
	return o.Results, true
}

// HasResults returns a boolean if a field has been set.
func (o *GetChannelTags200Response) HasResults() bool {
	if o != nil && !IsNil(o.Results) {
		return true
	}

	return false
}

// SetResults gets a reference to the given []GetChannelTags200ResponseResultsInner and assigns it to the Results field.
func (o *GetChannelTags200Response) SetResults(v []GetChannelTags200ResponseResultsInner) {
	o.Results = v
}

// GetTotal returns the Total field value if set, zero value otherwise.
func (o *GetChannelTags200Response) GetTotal() int32 {
	if o == nil || IsNil(o.Total) {
		var ret int32
		return ret
	}
	return *o.Total
}

// GetTotalOk returns a tuple with the Total field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GetChannelTags200Response) GetTotalOk() (*int32, bool) {
	if o == nil || IsNil(o.Total) {
		return nil, false
	}
	return o.Total, true
}

// HasTotal returns a boolean if a field has been set.
func (o *GetChannelTags200Response) HasTotal() bool {
	if o != nil && !IsNil(o.Total) {
		return true
	}

	return false
}

// SetTotal gets a reference to the given int32 and assigns it to the Total field.
func (o *GetChannelTags200Response) SetTotal(v int32) {
	o.Total = &v
}

func (o GetChannelTags200Response) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o GetChannelTags200Response) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.Results) {
		toSerialize["results"] = o.Results
	}
	if !IsNil(o.Total) {
		toSerialize["total"] = o.Total
	}
	return toSerialize, nil
}

type NullableGetChannelTags200Response struct {
	value *GetChannelTags200Response
	isSet bool
}

func (v NullableGetChannelTags200Response) Get() *GetChannelTags200Response {
	return v.value
}

func (v *NullableGetChannelTags200Response) Set(val *GetChannelTags200Response) {
	v.value = val
	v.isSet = true
}

func (v NullableGetChannelTags200Response) IsSet() bool {
	return v.isSet
}

func (v *NullableGetChannelTags200Response) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableGetChannelTags200Response(val *GetChannelTags200Response) *NullableGetChannelTags200Response {
	return &NullableGetChannelTags200Response{value: val, isSet: true}
}

func (v NullableGetChannelTags200Response) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableGetChannelTags200Response) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


